#define INCL_WIN
#define INCL_GPI
#include <os2.h>


static HMQ    hmq;
static QMSG   qmsg;
static HWND   hwndBase;
static HAB    hab;

MRESULT EXPENTRY BaseFrameProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
    HPS hps;
    RECTL rcl;
    PSZ txt = "Test text";
    COLOR clr = CLR_YELLOW;

    switch ( msg )
    {
        case WM_PAINT:
            hps = WinBeginPaint( hwnd , 0L , 0L );
            WinQueryWindowRect( hwnd , &rcl );
            GpiSetColor( hps , CLR_DARKCYAN );
            GpiSetBackColor( hps , clr );
            WinDrawText( hps , -1 , txt , &rcl , 0 , 0 ,
                         DT_TEXTATTRS | DT_CENTER | DT_VCENTER | DT_ERASERECT );
            WinEndPaint( hps );
            return 0;
    }
    return WinDefWindowProc( hwnd , msg , mp1 , mp2 );
}

void main()
{
    ULONG  flFrameFlags;
    char szBaseClientClass[] = "win.base";
    hab = WinInitialize( 0 );
    hmq = WinCreateMsgQueue( hab , 0 );
    WinRegisterClass( hab, szBaseClientClass, BaseFrameProc, CS_SIZEREDRAW, 0 );
    flFrameFlags = (FCF_TASKLIST | FCF_TITLEBAR | FCF_SIZEBORDER | FCF_SYSMENU | FCF_MINMAX);

    hwndBase = WinCreateStdWindow( HWND_DESKTOP, 0 ,&flFrameFlags , 
                                   szBaseClientClass , "test",
                                    0L , 0 , 1 , NULL );
                                    
    WinSetWindowPos( hwndBase, HWND_TOP, 100, 100, 200, 100,
                     SWP_SIZE | SWP_MOVE | SWP_SHOW | SWP_ACTIVATE );

    while ( WinGetMsg( hab, &qmsg, 0, 0, 0 ) ) {
        WinDispatchMsg( hab, &qmsg );
    }
    
    WinDestroyWindow( hwndBase );
    WinDestroyMsgQueue( hmq );
    WinTerminate( hab );
}

